class ExplanationPanel extends Element {
    var vote_labels, explanation_title, explanation_labels, format, bold_format;

    function ExplanationPanel(parent) {
        init(parent);
        vote_labels = [];
        for (var l = 0, y = 20; l < 12; l++, y += 20) {
            vote_labels.push(addtext(0, y, 500, 25));
        }
        explanation_title = addtext(300, 0, 500, 25);
        explanation_labels = [];
        for (var l = 0, y = 20; l < 6; l++, y += 20) {
            explanation_labels.push(addtext(300, y, 500, 25));
        }
        format = new TextFormat();
        format.size = 14;
        format.font = 'Arial';
        format.color = RGB.black;
        format.italic = false;
        format.bold = false;
        format.tabStops = [110];
        bold_format = new TextFormat();
        bold_format.bold = true;

        var vote_title = addtext(0, 0, 500, 25);
        vote_title.text = 'Preference rankings of voters';
        vote_title.setTextFormat(format);
        vote_title.setTextFormat(bold_format);
    }

    function show_election(
        method, votes, candidates, centroid, data, distribution) {
        for (var l = 0; l < vote_labels.length; l++) {
            vote_labels[l].text = '';
            explanation_labels[l].text = '';
        }
        for (var v = 0; v < votes.length; v++) {
            var ordered = [];
            for (var c = 0; c < candidates.length; c++) {
                ordered[votes[v].ranks[c]] = candidates[c].name;
            }
            var text = ordered.join(' > ') + ': ' +
                Methods.percent(votes[v].count);
            vote_labels[v].text = text;
            vote_labels[v].setTextFormat(format);
        }

        explanation_title.text = method.name + ': ' + method.description;
        explanation_title.setTextFormat(format);
        var bold = new TextFormat();
        bold.bold = true;
        explanation_title.setTextFormat(bold);

        var explanation = method.explain(
            votes, candidates, centroid, data, distribution);
        for (var e = 0; e < explanation.length; e++) {
            explanation_labels[e].text = explanation[e];
            explanation_labels[e].setTextFormat(format);
        }
    }
}
